;Assets
Global sprites = LoadImage("sprites.png")

Global level = LoadImage("level1.png")

Global boss1spr = LoadImage("boss.png")
Global boss2spr = LoadImage("boss2.png")
Global titlecard = LoadImage("titlecard.png")
Global music1 = LoadSound("adventure.wav")
Global font = LoadFont("Papyrus",34,True,False,False)
Global music2 = LoadSound("boss.wav")
LoopSound(music2)
Global music3 = LoadSound("boss2.wav")
LoopSound(music3)
Global crush = LoadSound("crush.wav")
Global jump = LoadSound("jump.wav")
Global shoot = LoadSound("shoot.wav")
Global explode = LoadSound("explode.wav")
Global finish = LoadSound("finish.wav")
Global die = LoadSound("die.wav")
;Type definitions
Type tile
Field x#
Field y#
End Type
Type spike
Field x#
Field y#
End Type
Type player
Field x#
Field y#
Field xspeed#
Field yspeed#
Field onground
Field flp = 1
End Type
Type enemy
Field x#
Field y#
Field direction
End Type
Type particle
Field x#
Field y#
Field xspeed#
Field yspeed#
Field t = 0
End Type
Type portal
Field x#
Field y#
Field rotation#
End Type
Type entile
Field x#
Field y#
End Type
Type enemy2
Field x#
Field y#
Field direction =0
End Type
Type boss1
Field x#
Field y#
Field direction
Field hp = 5
End Type
Type boss2
Field x#
Field y#
Field hp = 5
Field timer = 0
Field a = 0
End Type
Type spring
Field x#
Field y#
End Type
Type bullet
Field x#
Field y#
Field dead=0
End Type
Type missle
Field x#
Field y#
Field dead
End Type

;Graphics setup
window = CreateWindow("Bitendo Software  2013",(ClientWidth(Desktop())-width)/4 ,(ClientHeight(Desktop())-height)/4 ,800+6,480+28,0,1)
canvas = CreateCanvas(0,0,800,480,window)


SetBuffer CanvasBuffer(canvas)

Global deaths = 0
Global levelcount = 1
LoopSound music1
Global channel3 = PlaySound(music3)
Global channel2 = PlaySound(music2)
Global channel1 = PlaySound(music1)

DrawImage(level,0,0)
loadlevel()

bossShootTimer = 0

Global p.player = New player
p\x = 0
p\y = 480-34

titlescreen = 1


;Loop
Repeat

Cls

While WaitEvent(0) 
If EventID()=$803 End 
Wend 


If titlescreen = 0 Then


If KeyDown(32) And p\x < 800-32 Then

p\xspeed = 0.5
p\flp = 0

ElseIf KeyDown(30) And p\x > 0Then

p\xspeed = -0.5
p\flp = 1

Else

p\xspeed = 0

EndIf

For s.spike = Each spike

If RectsOverlap(p\x,p\y,32,32,s\x,s\y,32,32) Then

die()

EndIf

Next



For sp.spring = Each spring

If RectsOverlap(p\x,p\y,32,32,sp\x,sp\y,32,32) Then

p\yspeed = -2

EndIf

Next



For f.enemy = Each enemy

If f\direction = 1 Then f\x=f\x+0.5
If f\direction = 0 Then f\x=f\x-0.5

For c.entile = Each entile



If RectsOverlap(f\x,f\y,32,32,c\x,c\y,32,32)Then

If f\direction = 0 Then
f\direction =1
ElseIf f\direction=1 Then
f\direction = 0
EndIf

EndIf

Next

If RectsOverlap(f\x,f\y,32,32,p\x,p\y,32,32) Then

die()

EndIf

If RectsOverlap(f\x,f\y-4,32,4,p\x,p\y,32,32) Then

For i=0 To 3

e.particle = New particle
e\x = p\x
e\y = p\y
e\xspeed = Rnd(-4,4)
e\yspeed = Rnd(-1,0)
e\t = 1

Next
PlaySound(crush)
p\yspeed = -0.5
Delete f

EndIf

Next

For e.particle = Each particle

e\x = e\x + e\xspeed
e\y = e\y + e\yspeed
e\yspeed = e\yspeed + 0.1
If e\y > 480 Then

Delete e
EndIf

Next

p\onground = 0

For t.tile = Each tile

If RectsOverlap(p\x,p\y+32,32,1,t\x,t\y,32,32) Then 

p\onground = 1
p\yspeed = 0
p\y = t\y - 32

EndIf
If RectsOverlap(p\x+32,p\y,1,30,t\x,t\y,32,32)  And KeyDown(32) Then 

p\xspeed = 0

ElseIf RectsOverlap(p\x-1,p\y,1,30,t\x,t\y,32,32) And KeyDown(30) Then

p\xspeed = 0

EndIf

If RectsOverlap(p\x,p\y-1,32,1,t\x,t\y,32,32) And p\onground = 0 Then

p\yspeed = 0.1
p\y = p\y + 0.1

EndIf

Next

If p\onground = 0 Then

If p\yspeed < 2 Then

p\yspeed = p\yspeed + 0.01

EndIf


EndIf

If KeyHit(17) And p\onground Then

p\yspeed = -1.2
PlaySound(jump)

EndIf


p\x = p\x + p\xspeed
p\y = p\y + p\yspeed

For pp.portal = Each portal

If RectsOverlap(p\x,p\y,32,32,pp\x,pp\y,32,32) Then

levelcount=levelcount+1

level = LoadImage("level"+levelcount+".png")
DrawImage(level,0,0)
loadlevel()
p\x = 0
p\y = 480-34
PlaySound(finish)

EndIf

Next

For ff.enemy2 = Each enemy2

If ff\direction = 1 Then ff\y=ff\y-0.5
If ff\direction = 0 Then ff\y=ff\y+0.5
For ii.tile = Each tile

If RectsOverlap(ff\x,ff\y,32,32,ii\x,ii\y,32,32) Then

If ff\direction = 0 Then
ff\direction = 1
ElseIf ff\direction =1 Then
ff\direction=0
EndIf

EndIf
If ff\y >= 480-64 Then

ff\direction = 1

EndIf

Next
If RectsOverlap(ff\x,ff\y,32,32,p\x,p\y,32,32) Then

die()

EndIf


Next
For bb.boss1 = Each boss1

If bb\direction = 1 Then bb\x=bb\x+1
If bb\direction = 0 Then bb\x=bb\x-1

If bossShootTimer < 500 Then

bossShootTimer = bossShootTimer + 1

Else

buile.bullet = New bullet
buile\x=bb\x+(64-4)
buile\y = bb\y+64
buile\dead = 0
bossShootTimer = 0

EndIf

If RectsOverlap(bb\x,bb\y,128,64,p\x,p\y,32,32) Then

die()

EndIf

If RectsOverlap(bb\x,bb\y-4,128,4,p\x,p\y,32,32) Then
bb\hp = bb\hp - 1
p\yspeed = -2
For i=0 To 3
e.particle = New particle
e\x = bb\x
e\y = bb\y
e\xspeed = Rnd(-4,4)
e\yspeed = Rnd(-1,0)
e\t = 1
Next

PlaySound(crush)

EndIf



For cc.entile = Each entile



If RectsOverlap(bb\x,bb\y,128,64,cc\x,cc\y,32,32)Then

If bb\direction = 0 Then
bb\direction =1
ElseIf bb\direction=1 Then
bb\direction = 0
EndIf

EndIf

Next

If bb\hp = 0 Then

PlaySound(die)

For i=0 To 10
e.particle = New particle
e\x = bb\x
e\y = bb\y
e\xspeed = Rnd(-4,4)
e\yspeed = Rnd(-1,0)
e\t = 1
If i=10 Then
e\t = 2
EndIf
Next



pdp.portal = New portal
pdp\x = 400-16
pdp\y = 300+16

Delete bb



EndIf
Next

For bs2.boss2 = Each boss2

If bs2\timer < 100 Then
bs2\timer = bs2\timer + 1
Else
bs2\timer = 0
If bs2\a = 0 Then
bs2\a = 1
ElseIf bs2\a = 1 Then
bs2\a = 0
EndIf

EndIf


If bossShootTimer < 2500 Then

bossShootTimer = bossShootTimer + 1

Else

For i=0 To 1

bc.missle = New missle
bc\x = bs2\x-34
bc\y = Rnd(bs2\y,bs2\y+(256-32))

Next
bossShootTimer = 0

EndIf

If RectsOverlap(p\x,p\y,32,32,bs2\x,bs2\y,256,256) Then
die()
EndIf

If RectsOverlap(bs2\x,bs2\y-4,256,4,p\x,p\y,32,32) Then

For i=0 To 2

e.particle = New particle
e\x = p\x
e\y = p\y
e\xspeed = Rnd(-4,4)
e\yspeed = Rnd(-1,0)
e\t = 1

Next

PlaySound(crush)
p\x = 34
p\yspeed = -0.5

bs2\hp = bs2\hp - 1
EndIf




If bs2\hp = 0 Then

PlaySound(die)

For i=0 To 10
e.particle = New particle
e\x = bs2\x
e\y = bs2\y
e\xspeed = Rnd(-4,4)
e\yspeed = Rnd(-1,0)
e\t = 1
If i=10 Then
e\t = 2
EndIf
Next



pddp.portal = New portal
pddp\x = 400-16
pddp\y = 300-32

For asdf.missle = Each missle
Delete asdf
Next

Delete bs2



EndIf




Next


;;;;;;;;
For bu2.missle = Each missle
;Move towards player

If p\x > bu2\x Then bu2\x = bu2\x + 0.1
If p\x < bu2\x Then bu2\x = bu2\x - 0.1
If p\y > bu2\y Then bu2\y = bu2\y + 0.3
If p\y < bu2\y Then bu2\y = bu2\y - 0.15

;end


If RectsOverlap(bu2\x,bu2\y,32,32,p\x,p\y,32,32) Then
bu2\dead = 1
die()
EndIf


If RectsOverlap(bu2\x,bu2\y-4,32,4,p\x,p\y,32,32) Then
p\yspeed = -4
bu2\dead = 1
EndIf

If bu2\dead = 1 Then Delete bu2

Next

;Rendering
For t.tile = Each tile

DrawImageRect(sprites,t\x,t\y,32,32,32,32)

Next
For s.spike = Each spike

DrawImageRect(sprites,s\x,s\y,0,32,32,32)

Next

For a.portal = Each portal
DrawImageRect(sprites,a\x,a\y,80,32,32,32)
Next

For e.particle = Each particle

If e\t = 0 Then DrawImageRect(sprites,e\x,e\y,64,32,8,8)
If e\t = 1 Then DrawImageRect(sprites,e\x,e\y,72,32,8,8)
If e\t = 2 Then DrawImageRect(boss1spr,e\x,e\y,0,64,128,64)

Next

For bs22.boss2 = Each boss2

If bs22\a = 0 Then
DrawImageRect(boss2spr,bs22\x,bs22\y,0,0,256,256)
ElseIf bs22\a = 1 Then
DrawImageRect(boss2spr,bs22\x,bs22\y,256,0,256,256)
EndIf

Next

For f.enemy = Each enemy

If f\direction = 1 Then
DrawImageRect(sprites,f\x,f\y,64,0,32,32)
ElseIf f\direction = 0 Then
DrawImageRect(sprites,f\x,f\y,96,0,32,32)
EndIf

Next

For fff.enemy2 = Each enemy2


DrawImageRect(sprites,fff\x,fff\y,112,32,32,32)


Next

For bbb.boss1 = Each boss1

DrawImageRect(boss1spr,bbb\x,bbb\y,0,0,128,64)

Next

For spp.spring = Each spring
DrawImageRect(sprites,spp\x,spp\y,0,64,32,32)
Next

For bulleeet.bullet = Each bullet

DrawImageRect(sprites,bulleeet\x,bulleeet\y,64,40,8,8)

Next

For but.missle = Each missle

DrawImageRect(boss2spr,but\x,but\y,0,512,32,32)

Next


If p\flp = 0 Then
DrawImageRect(sprites,p\x,p\y,0,0,32,32)
Else
DrawImageRect(sprites,p\x,p\y,32,0,32,32)
EndIf

;Render HUD

Color 255,160,66
Rect 0,0,800,16
Color 255,255,255

Text 0,0,"Deaths: " + deaths,0,0
Text 400,0,"Level "+levelcount,1,0


For bull.bullet = Each bullet

bull\y = bull\y + 0.8 


If RectsOverlap(bull\x,bull\y,8,8,p\x,p\y,32,32) Then

die()

EndIf



For eee.tile = Each tile

If RectsOverlap(bull\x,bull\y,8,8,eee\x,eee\y,32,32) Then

bull\dead = 1

EndIf




Next


If bull\dead = 1 Then
Delete bull
EndIf

Next

If levelcount = 17 Then

Text 400,300+32,"Congraturations! Thanks so much for-to playing my crap",1,1

EndIf

Else

;Titlescreen

DrawImage(titlecard,0,0)

Color 255,0,0

SetFont font
Text 400,150,"The Rings Of Combustion",1,1
font2 = LoadFont("Arial",12,True,False,False)
SetFont font2
Text 400,300,"Press Enter to Start",1,1

If KeyHit(28) Then titlescreen=0


EndIf

Nowtimer=MilliSecs()-Lasttimer
	If nowtimer<3
		Repeat:Until MilliSecs()-Lasttimer>=3
	Else

	EndIf

Lasttimer=MilliSecs()


FlipCanvas canvas



Forever














;Functions
Function loadlevel()
PauseChannel(channel1)
PauseChannel(channel2)
PauseChannel(channel3)
If levelcount = 7 Then
PauseChannel(channel1)
ResumeChannel(channel2)
PauseChannel(channel3)
ElseIf levelcount = 15 Then
PauseChannel(channel1)
PauseChannel(channel2)
PauseChannel(channel3)
ElseIf levelcount = 16 Then
PauseChannel(channel1)
PauseChannel(channel2)
ResumeChannel(channel3)
Else
PauseChannel(channel2)
ResumeChannel(channel1)
PauseChannel(channel3)
EndIf

LockBuffer

For a.tile = Each tile

Delete a

Next
For b.spike = Each spike
Delete b
Next
For c.enemy = Each enemy
Delete c
Next
For d.particle = Each particle
Delete d
Next
For e.portal = Each portal
Delete e
Next
For f.entile = Each entile
Delete f
Next
For ff.enemy2 = Each enemy2
Delete ff
Next
For bbbbb.boss1 = Each boss1
Delete bbbbb
Next
For sss.spring = Each spring
Delete sss
Next
For bdb.boss2 = Each boss2
Delete bdb
Next


For i=0 To 24
For j = 0 To 14
pix = ReadPixelFast(i,j)
If GetR(pix)=127 And GetG(pix)=106 And GetB(pix)=0 Then


g.tile = New tile
g\x = i * 32
g\y = j * 32

ElseIf GetR(pix) = 160 And GetG(pix)=160 And GetB(pix) = 160 Then

h.spike = New spike
h\x = i * 32
h\y = j * 32

ElseIf GetR(pix) = 182 And GetG(pix) = 255 And GetB(pix) = 0 Then

k.portal = New portal
k\x = i * 32
k\y = j * 32

ElseIf GetR(pix) = 255 And GetG(pix) = 0 And GetB(pix) = 0 Then

l.enemy = New enemy
l\x = i * 32
l\y = j * 32
l\direction = Rand(0,1)

ElseIf GetR(pix) = 0 And GetG(pix) = 74 And GetB(pix) = 127 Then

m.entile = New entile
m\x = i * 32
m\y = j * 32


ElseIf GetR(pix) = 64 And GetG(pix) = 64 And GetB(pix) = 64 Then

n.enemy2 = New enemy2
n\x = i * 32
n\y = j * 32

ElseIf GetR(pix) = 127 And GetG(pix) = 0 And GetB(pix) = 55 Then

nn.boss1 = New boss1
nn\x = i * 32
nn\y = j * 32
nn\direction = 1
nn\hp = 5

ElseIf GetR(pix) =255 And GetG(pix) = 106 And GetB(pix) = 0 Then

sppp.spring = New spring
sppp\x = i * 32
sppp\y = j * 32

ElseIf GetR(pix) =255 And GetG(pix) = 255 And GetB(pix) = 255 Then

ddd.boss2 = New boss2
ddd\x = i * 32
ddd\y = j * 32
bossShootTimer = 4000
ddd\hp = 8



EndIf

Next
Next

UnlockBuffer

End Function





Function GetR(rgb%)
Local r=(rgb And $ff0000)/$10000: Return r
End Function

Function GetG(rgb%)
Local g=(rgb And $ff00)/$100: Return g
End Function

Function GetB(rgb%)
Local b=rgb And $ff: Return b
End Function



Function die()

For bbd.boss1 = Each boss1
bbd\hp = 5
Next
For bbdd.boss2 = Each boss2
If bbdd\hp > 8 Then
bbdd\hp=bbdd\hp + 1
EndIf
Next

PlaySound(die)
deaths = deaths + 1

For i=0 To 3

e.particle = New particle
e\x = p\x
e\y = p\y
e\xspeed = Rnd(-4,4)
e\yspeed = Rnd(-1,0)
e\t = 0

Next

p\x = 0
p\y = 480-34


End Function